/*
 * Created on: Jul 28, 2024
 */

#include <stdint.h>

#include "adc.h"
#include "btn.h"
#include "led.h"
#include "ledprog_pep.h"
#include "ledprog_rgb.h"



#define MODE_RUN                0
#define MODE_PROGRAM            1
#define MODE_PARAMETER          2

#define UI_CONF_SAVE_TIMEOUT    160

#define UI_PROG_RUNTIME_MIN     (128*15)    // 15 seconds
#define UI_PROG_RUNTIME_MAX     (128*120)   // 120 seconds



static const uint8_t led_gc_map[] = {
    48, 40, 34, 32,      // 0 = maybe outside, or really bright inside. 1-3 = indoors
    30, 28, 27, 25,     // 4-7 = indoors
    23, 21, 19, 18,     // 8-11 = indoors normal
    17, 16, 15, 13,     // 12 = dimmest normal, 13 = darker, 14-15 darker still
    11,  9,  7,  5,     // 16-19 = from night room light to computer light
    0                   // 20 = outside mode turns off the LEDs
};

static uint8_t mode = MODE_RUN;
static uint8_t tick = 0;



void ui_btn_push_cb(uint8_t idx)
{

}

void ui_btn_hold_cb(uint8_t idx)
{

}

void ui_btn_release_cb(uint8_t idx)
{

}



void ui_init()
{
    btn[0].hold = 330 >> 1;
    btn[0].repeat = 0; // (1000 / 20) >> 1;
    btn[0].cb_push = ui_btn_push_cb;
    btn[0].cb_hold = ui_btn_hold_cb;
    btn[0].cb_release = ui_btn_release_cb;

    btn[1].hold = 330 >> 1;
    btn[1].repeat = 0;
    btn[1].cb_push = ui_btn_push_cb;
    btn[1].cb_hold = ui_btn_hold_cb;
    btn[1].cb_release = ui_btn_release_cb;
}

uint8_t tmp;
volatile uint8_t prog_run = 5;

void ui_render()
{
    uint8_t w;

    tick++;

    switch (mode) {
        case MODE_RUN: {
            break;
        }

        case MODE_PROGRAM: {
            break;
        }

        case MODE_PARAMETER: {
            break;
        }
    }

    // set LED current based on brightness
    w = adc_get_lsens_coarse();
    if (w > 19) w = 19;
    if (!w) {
        // are you outside? why? it's too fucking hot
        // we'll shut down when in the presence of big nuclear fire
        if (adc_get_lsens() < 400) {
            // yup, outside or in a spotlight at 3ft away or something
            w = 20;
        }
    }
    is31fl3729_set_global_current(FL3729_ADDR, led_gc_map[w]);

    // temporary: testing

    ledprog_pep[prog_run](tick);
    /*
    if ((tick & 3) == 3) {

        tmp++;
        tmp &= 0x3f;

        for (uint8_t i = 0; i < 64; i++) {
            if (i == tmp) led.all[i] = 255;
            else led.all[i] = 0;
        }

        led_matrix_is_updated();
    }
    */
}
